import type { AxiosInstance } from 'axios';

declare type Actions = 'c' | 'r' | 'u' | 'd' | 'getList' | 'updateStatus' | 'enable' | 'disable' | any;

declare interface Form {
    show?: boolean;
    data?: any;
    dataAt?: string | ((...args: any) => unknown);
    mergeData?: MergeData;
    loading?: boolean;
    submitting?: boolean;
    status?: Status;
}

declare type GetList = (payload: any, payloadAs?: PayloadAs) => Promise<any>;

declare interface List {
    filter: Record<keyof any, any>;
    pageNumberKey: string;
    watchFilter?: boolean;
    debounceInterval?: number;
    data?: any[];
    dataAt?: string | ((...args: any) => unknown);
    total?: number;
    totalAt?: string | ((...args: any) => unknown);
    loading?: boolean;
}

declare type MergeData = 'deep' | 'shallow' | false | ((newFormData: any) => any);

declare type OpenForm = (payload: any, payloadAs?: PayloadAs | 'cache') => Promise<any> | undefined;

export declare type PayloadAs = 'data' | 'params' | 'config' | undefined;

declare type Status = '' | 'c' | 'r' | 'u' | string;

declare type SubmitForm = (params: any) => Promise<any>;

export declare function unwrap<V = any>(value: V, path?: string | ((value: V) => any) | symbol): any;

declare function useAdmate({ axios, axiosConfig, urlPrefix, form, list, getListProxy, openFormProxy, submitFormProxy, }: {
    axios: AxiosInstance;
    axiosConfig: Record<Actions, object | ((objForConfig: object) => object)>;
    urlPrefix: string;
    form?: Form;
    list?: List;
    getListProxy?: (getList: GetList, trigger?: string) => void;
    openFormProxy?: (openForm: OpenForm) => Promise<Form> | Form | undefined;
    submitFormProxy?: (submitForm: SubmitForm) => Promise<Form> | Form | undefined;
}): {
    list: List;
    getList: (...args: any) => Promise<unknown> | void;
    form: Form;
    openForm: (...args: any) => Form | Promise<any> | undefined;
    submitForm: (...args: any) => Form | Promise<any> | undefined;
    d: (payload: any, payloadAs: PayloadAs) => Promise<unknown>;
    enable: (payload: any, payloadAs: PayloadAs) => Promise<unknown>;
    disable: (payload: any, payloadAs: PayloadAs) => Promise<unknown>;
    updateStatus: (payload: any, payloadAs: PayloadAs) => Promise<unknown>;
};
export default useAdmate;

export { }
